#!/usr/bin/python
import os
basedir = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
import pandas as pd
from math import pi
import argparse

IMC_INTERNAL_UNITS = 65520
CURRENT_PEAK = 40
ENCODER_BITS = 16
HOUR_IN_SECONDS = 3600

class CalcBatteryCapacity(object):
    """
    Goal is to gain insight in the required size for the batteries.
    This  was made at the request of the electrical engineers.
    """

    def __init__(self, filename: str, sampling_time=0.004):
        """
        Creates and checks for the required directories and files
        :param filename: .ftr file that containts the data, has to to be an imc_states
        :param sampling_time: sampling time used in the training in seconds
        """
        self.ftrdir = os.path.join(basedir, "ftr/")
        self.filepath = os.path.join(self.ftrdir, filename)
        if not os.path.isfile(self.filepath):
            raise Exception("file does not exist")

        self.data_frame = pd.read_feather(self.filepath)
        self.time_in_sec = len(self.data_frame.index) * sampling_time
        self.sampling_time = sampling_time
        self.filebase = filename.replace('.ftr', '')

        print(self.filebase)
        print("The training lasted: ", self.time_in_sec, "seconds | ", self.time_in_sec/HOUR_IN_SECONDS, "hour")

    def calc_capacity(self, store=False):
        """
        Plots the current over time, and computes the total capacity.
        :param store: if True, the plots ands total capacity will be stored in 'analysis/filename'
        :return:
        """
        if store:
            txtdir = os.path.join(basedir, 'analysis', self.filebase, 'logs')
            os.makedirs(txtdir, exist_ok=True)
            txtfile = open(os.path.join(txtdir, "motor_current.txt"), "w")

        total_pos_capacity = 0
        total_neg_capacity = 0

        encoder_resolution = 2**ENCODER_BITS  # Encoder has 16 bit resolution
        velocity_conversion = 1 / encoder_resolution / (2 * pi)

        # Assumed linear relation between current and torque
        # https://technosoftmotion.com/wp-content/uploads/2019/10/P091.064.EtherCAT.iPOS_.UM_.pdf
        torque_conversion = IMC_INTERNAL_UNITS / CURRENT_PEAK / 2

        # Compute per motor, to gain insight what each motor consumes capacity wise
        number_of_motors = 8
        for i in range(number_of_motors):
            motor_current_number = f'motor_current_{str(i)}'
            motor_velocity_number = f'incremental_velocity_{str(i)}'

            # The capacity of a motor can be computed by integrating to torque over the angular velocity.
            # The torque can be estimated using the current and the motor characteristics.
            motor_current = self.data_frame.loc[:, motor_current_number]
            motor_velocity = self.data_frame.loc[:, motor_velocity_number]

            # The velocity in the logs is by encoder increments, and needs a conversion to rad/s.
            # Velocity direction is irrelevant for consumed or generated capacity
            velocity = abs(motor_velocity) * velocity_conversion

            # The negative current is not send into back into the battery (regenitive breaking),
            # so only the positive current is important to determine how large the batteries should be
            where_is_current_positive = motor_current >= 0

            # Compute power at every time step, and integrate over time. Finally convert to Watthour (Wh)
            pos_torque = motor_current[where_is_current_positive] * torque_conversion
            pos_capacity = (pos_torque * velocity).sum()
            pos_capacity = abs(pos_capacity * self.sampling_time / HOUR_IN_SECONDS)

            # Negative current shows how much capacity could be recovered with regenitive breaking
            where_is_current_negative = motor_current < 0
            neg_torque = motor_current[where_is_current_negative] * torque_conversion
            neg_capacity = (neg_torque * velocity).sum()
            neg_capacity = abs(neg_capacity * self.sampling_time / HOUR_IN_SECONDS)

            # Sum the capacities over all motors
            total_pos_capacity += pos_capacity
            total_neg_capacity += neg_capacity

            print_lines = [f'The total battery capacity of motor {i} is:\n',
                           f'\t Used by the motor: \t {pos_capacity}  Wh\n'
                           f'\t Generated by braking: \t {neg_capacity}  Wh\n']
            print(*print_lines)

            if store:
                txtfile.writelines(print_lines)

        print_lines_total = [f'The total battery capacity is:\n',
                             f'\t Used by the motor: \t {total_pos_capacity}  Wh\n'
                             f'\t Generated by braking: \t {total_neg_capacity}  Wh\n']

        print(*print_lines_total)
        if store:
            txtfile.writelines(print_lines_total)
            txtfile.close()


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("filename", help="Full name of the feather file, including '.ftr'", type=str)
    parser.add_argument("-s", "--store", help="If provided, will save the computations to a text file",
                        action="store_true")
    args = parser.parse_args()
    try:
        # Caluclate the capacity
        CalcBatteryCapacity(args.filename).calc_capacity(args.store)
    except FileNotFoundError:
        print(f'Cannot find file: {args.filename}')


if __name__ == '__main__':
    main()

